diff --git a/arch/arm/dts/armada-388-clearfog.dts b/arch/arm/dts/armada-388-clearfog.dts
index b2dfd56..196ff0e 100644
--- a/arch/arm/dts/armada-388-clearfog.dts
+++ b/arch/arm/dts/armada-388-clearfog.dts
@@ -342,7 +342,7 @@
 				pinctrl-names = "default";
 				status = "okay";
 
-				spi-flash@0 {
+				spi-nor@0 {
 					#address-cells = <1>;
 					#size-cells = <0>;
 					compatible = "w25q32", "jedec,spi-nor";
diff --git a/arch/arm/dts/armada-388-gp.dts b/arch/arm/dts/armada-388-gp.dts
index 7bc878f..c9ff1e0 100644
--- a/arch/arm/dts/armada-388-gp.dts
+++ b/arch/arm/dts/armada-388-gp.dts
@@ -73,7 +73,7 @@
 				status = "okay";
 				u-boot,dm-pre-reloc;
 
-				spi-flash@0 {
+				spi-nor@0 {
 					u-boot,dm-pre-reloc;
 					#address-cells = <1>;
 					#size-cells = <1>;
diff --git a/arch/arm/dts/armada-xp-gp.dts b/arch/arm/dts/armada-xp-gp.dts
index 27799d1..77b6c86 100644
--- a/arch/arm/dts/armada-xp-gp.dts
+++ b/arch/arm/dts/armada-xp-gp.dts
@@ -230,7 +230,7 @@
 				status = "okay";
 				u-boot,dm-pre-reloc;
 
-				spi-flash@0 {
+				spi-nor@0 {
 					u-boot,dm-pre-reloc;
 					#address-cells = <1>;
 					#size-cells = <1>;
diff --git a/arch/arm/dts/armada-xp-maxbcm.dts b/arch/arm/dts/armada-xp-maxbcm.dts
index d7d7f65..371346d 100644
--- a/arch/arm/dts/armada-xp-maxbcm.dts
+++ b/arch/arm/dts/armada-xp-maxbcm.dts
@@ -228,7 +228,7 @@
 			spi0: spi@10600 {
 				status = "okay";
 
-				spi-flash@0 {
+				spi-nor@0 {
 					#address-cells = <1>;
 					#size-cells = <1>;
 					compatible = "n25q128a13", "jedec,spi-nor";
diff --git a/arch/arm/dts/armada-xp-synology-ds414.dts b/arch/arm/dts/armada-xp-synology-ds414.dts
index 0a60ddf..1273bf4 100644
--- a/arch/arm/dts/armada-xp-synology-ds414.dts
+++ b/arch/arm/dts/armada-xp-synology-ds414.dts
@@ -84,7 +84,7 @@
 				status = "okay";
 				u-boot,dm-pre-reloc;
 
-				spi-flash@0 {
+				spi-nor@0 {
 					u-boot,dm-pre-reloc;
 					#address-cells = <1>;
 					#size-cells = <1>;
diff --git a/arch/arm/dts/armada-xp-theadorable.dts b/arch/arm/dts/armada-xp-theadorable.dts
index cf1be2a..1ab1a7c 100644
--- a/arch/arm/dts/armada-xp-theadorable.dts
+++ b/arch/arm/dts/armada-xp-theadorable.dts
@@ -129,7 +129,7 @@
 				status = "okay";
 				u-boot,dm-pre-reloc;
 
-				spi-flash@0 {
+				spi-nor@0 {
 					u-boot,dm-pre-reloc;
 					#address-cells = <1>;
 					#size-cells = <1>;
diff --git a/arch/arm/dts/tegra30-beaver.dts b/arch/arm/dts/tegra30-beaver.dts
index ae83636..17af221 100644
--- a/arch/arm/dts/tegra30-beaver.dts
+++ b/arch/arm/dts/tegra30-beaver.dts
@@ -187,7 +187,7 @@
 	spi@7000da00 {
 		status = "okay";
 		spi-max-frequency = <25000000>;
-		spi-flash@1 {
+		spi-nor@1 {
 			compatible = "winbond,w25q32";
 			reg = <1>;
 			spi-max-frequency = <20000000>;
diff --git a/arch/x86/dts/bayleybay.dts b/arch/x86/dts/bayleybay.dts
index 1d6f0fc..6e1fb19 100644
--- a/arch/x86/dts/bayleybay.dts
+++ b/arch/x86/dts/bayleybay.dts
@@ -148,7 +148,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich9-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					#address-cells = <1>;
 					#size-cells = <1>;
 					reg = <0>;
diff --git a/arch/x86/dts/broadwell_som-6896.dts b/arch/x86/dts/broadwell_som-6896.dts
index 2487091..426f491 100644
--- a/arch/x86/dts/broadwell_som-6896.dts
+++ b/arch/x86/dts/broadwell_som-6896.dts
@@ -38,7 +38,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich9-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					reg = <0>;
 					compatible = "winbond,w25q128", "jedec,spi-nor";
 					memory-map = <0xff000000 0x01000000>;
diff --git a/arch/x86/dts/chromebook_link.dts b/arch/x86/dts/chromebook_link.dts
index 040f917..abb3e58 100644
--- a/arch/x86/dts/chromebook_link.dts
+++ b/arch/x86/dts/chromebook_link.dts
@@ -390,7 +390,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich9-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					#size-cells = <1>;
 					#address-cells = <1>;
 					reg = <0>;
diff --git a/arch/x86/dts/chromebox_panther.dts b/arch/x86/dts/chromebox_panther.dts
index 6fb3fc1..3711594 100644
--- a/arch/x86/dts/chromebox_panther.dts
+++ b/arch/x86/dts/chromebox_panther.dts
@@ -41,7 +41,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich9-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					#size-cells = <1>;
 					#address-cells = <1>;
 					reg = <0>;
diff --git a/arch/x86/dts/cougarcanyon2.dts b/arch/x86/dts/cougarcanyon2.dts
index 80a6e14..8007387 100644
--- a/arch/x86/dts/cougarcanyon2.dts
+++ b/arch/x86/dts/cougarcanyon2.dts
@@ -71,7 +71,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich9-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					reg = <0>;
 					compatible = "winbond,w25q64bv", "jedec,spi-nor";
 					memory-map = <0xff800000 0x00800000>;
diff --git a/arch/x86/dts/crownbay.dts b/arch/x86/dts/crownbay.dts
index 5a7dfe8..c7c659f 100644
--- a/arch/x86/dts/crownbay.dts
+++ b/arch/x86/dts/crownbay.dts
@@ -219,7 +219,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich7-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					reg = <0>;
 					compatible = "sst,25vf016b",
 						"jedec,spi-nor";
diff --git a/arch/x86/dts/galileo.dts b/arch/x86/dts/galileo.dts
index 8d8b9fe..11ceddd 100644
--- a/arch/x86/dts/galileo.dts
+++ b/arch/x86/dts/galileo.dts
@@ -121,7 +121,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich7-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					#size-cells = <1>;
 					#address-cells = <1>;
 					reg = <0>;
diff --git a/arch/x86/dts/minnowmax.dts b/arch/x86/dts/minnowmax.dts
index acffaa7..046276f 100644
--- a/arch/x86/dts/minnowmax.dts
+++ b/arch/x86/dts/minnowmax.dts
@@ -181,7 +181,7 @@
 				#address-cells = <1>;
 				#size-cells = <0>;
 				compatible = "intel,ich9-spi";
-				spi-flash@0 {
+				spi-nor@0 {
 					#address-cells = <1>;
 					#size-cells = <1>;
 					reg = <0>;